;************************************
;*    CV Manipulation setzen        *
;************************************
;hier werden neue CV Manipulationsbefehle gesetzt (POM)

CV_edit:
        mov       w,byteB              ; auf CV Byte schreiben testen
        cbr       w,0b00000011         ; adressbits ausblenden
        cpi       w,0b11101100
        breq      PC+2                 ; wenn CV Byte schreiben 1x springen
        rjmp      Hauptschleife        ; wenn nicht zurck

        cp        ProgTest,ByteE       ; vergleiche mit vorherigen Daten (XOR-Byte)
        breq      PC+3                 ; springe 3x wenn gleich
        mov       ProgTest,ByteE       ; ansonsten merke letzte Daten zum vergleich auf 2x Gleiche Daten
        rjmp      Hauptschleife        ; und zurck

        in        w,ADCSRA             ; adc int. wieder einschalten
        cbr       w,(1<<ADIE)
        out       ADCSRA,w
        ldi       zl,low(CVtest*2)     ; zl/h auf CVmin setzen
        ldi       zh,high(CVtest*2)
        mov       w,byteC              ; zu schreibendes Cv auf min/max testen
        clc                            ; dazu CV# * 2 (da je 2 werte) zu CVmin in z addieren
        rol       w                    ;
        add       zl,w
        clr       w
        adc       zh,w
        lpm       w,z+                 ; CVmin holen
        cp        byteD,w              ; neue Daten mit minimal Wert vergleichen
        brsh      PC+2                 ; wenn grer oder gleich 1x springen
        rjmp      Hauptschleife        ; ansonsten Fehler -> zurck
        lpm       w,z                  ; CVmax holen
        cp        w,byteD              ; maxWert mit neuen Daten vergleichen
        brsh      PC+2                 ; wenn grer oder gleich 1x springen
        rjmp      Hauptschleife        ; ansonsten Fehler -> zurck
        mov       eead,byteC           ; setzte EEprom Adresse
        mov       w,byteD              ; setze Daten
        rcall     eepromschreiben      ; sichere neue Daten im EEprom
        rcall     EEpromDatenlesen     ; und Dekoderdaten neu einlesen

        ldi       zl,LOW(EMK)          ; den Z-Pointer wieder mit dem Start der Generator Bytes laden
        ldi       zh,HIGH(EMK)
        in        w,ADCSRA             ; adc int. wieder einschalten
        cbr       w,(1<<ADIF)
        sbr       w,(1<<ADIE)
        out       ADCSRA,w
        rjmp      Hauptschleife        ; und fertig

;************************************
;*    CV Progmodus-ServiceMode      *
;************************************
; hier Dekoder Service Mode bearbeiten
; wenn Reset/Grundstellungspaket empfangen wurde, dann wird automatisch danach hierher verzweigt

ServiceMode:
        tst       byteA                ; auf DekoderReset testen
        brne      PC+2                 ; wenn nicht 1x springen
        rjmp      DCCreset             ; wenn ja gleich zurck

        mov       w,byteA              ;
        cpi       w,0b01111100         ; prfe Funktionscode auf CV Write Byte Schreiben
        breq      PC+3                 ; wenn richtig 2x springen
        cbr       flag,(1<<resetbit)   ; wenn etwas anderes kommt lsche Reset und gehe zu
        rjmp      Hauptschleife

        cp        ProgTest,ByteD       ; vergleiche mit vorherigen Daten (XOR-Byte)
        breq      PC+3                 ; springe 3x wenn gleich
        mov       ProgTest,ByteD       ; ansonsten merke letzte Daten zum vergleich auf 2x Gleiche Daten
        rjmp      Hauptschleife        ; und zurck

        cli                            ; int ausschalten
        ldi       zl,low(CVtest*2)     ; zl/h auf CVmin setzen
        ldi       zh,high(CVtest*2)
        mov       w,byteB              ; zu schreibendes Cv auf min/max testen
        clc                            ; dazu CV# * 2 (da je 2 werte) zu CVmin in z addieren
        rol       w                    ;
        add       zl,w
        clr       w
        adc       zh,w
        lpm       w,z+                 ; CVmin holen
        cp        byteC,w              ; neue Daten mit minimal Wert vergleichen
        brsh      PC+2                 ; wenn grer oder gleich 1x springen
        rjmp      reset                ; ansonsten Fehler -> reset machen
        lpm       w,z                  ; CVmax holen
        cp        w,byteC              ; maxWert mit neuen Daten vergleichen
        brsh      PC+2                 ; wenn grer oder gleich 1x springen
        rjmp      reset                ; ansonsten Fehler -> reset machen
        mov       eead,byteB           ; setzte EEprom Adresse
        mov       w,byteC              ; setze Daten
        rcall     eepromschreiben      ; sichere neue Daten im EEprom
Progbest:
        sbi       PortB,MotPWM         ; fr min 6 ms (hier 12,8ms) mind 60mA mehr Strom flieen lassen
        ldi       w,155
        out       TCNT0,w              ; setze Zeit fr Besttigung
        ldi       w,0b00000101         ; 1 0 1 CK/1024 fr Resetzeit
        out       TCCR0,w
        in        w,TIFR               ; hole Timer Interuptflag
        sbrs      w,TOV0               ; wenn Ackzeit abgelaufen
        rjmp      PC-2                 ; Schleife
        clr       w
        out       TCCR0,w              ; Timer wieder abschalten
        cbi       PortB,MotPWM         ; lsche Motorausgang
        cbr       flag,(1<<resetbit)   ; lsche Reset und dann normal weiter
        ldi       zl,LOW(EMK)          ; den Z-Pointer wieder mit dem Start der Generator Bytes laden
        ldi       zh,HIGH(EMK)
        sei                            ; alle Interrupts wieder einschalten
        rjmp      Hauptschleife        ; und normal weiter


; min/max fr CVs
CVtest:
.DB 1,127         ;CV1 Dekoderaddresse 1-127
.DB 0,63          ;CV2 Minimale Geschwindigkeit 0-63
.DB 0,$FF         ;CV3 Anfahrverzgerung 1-256 1=1,28ms je Schritt 0(256)=327,68ms je Schritt
.DB 0,$FF         ;CV4 Bremsverzgerung 1-256 w.o.
.DB 25,150        ;CV5 Maximale Geschwindigkeit in 6 Stufen: 25% 50% 75% 100% 125% 150%
.DB $FF,$FF       ;CV6
.DB 1,1           ;CV7 Software-Version
.DB $0D,$0D       ;CV8 Herstellerkennung
.DB 0,4           ;CV9 Motor PWM-Periode 0-4 0=30Hz 1=120Hz 2=500Hz 3=16KHz 4=32KHz
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB 192,231       ;CV17 Erweiterte Adresse Hherwertiges Byte der langen Adresse plus 192
.DB 0,$FF         ;CV18 Erweiterte Adresse Niederwertiges Byte der langen Adresse
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB 0,$FF         ;CV29 Konfiguration nach DCC-Norm
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB 0,10          ;CV50 Dimmen der Lichtausgnge 0-10
.DB 0,0           ;CV51 Vmerken hier letzte Geschwindigkeit+Richtung merken
.DB 0,63          ;CV52 Schrittweite der Lastreglung 0=aus Wert liegt zw 1 und ca 10 max 63
.DB 0,127         ;CV53 Max Anzahl der Korrekturschritte (aus CV52) zur Lastreglung 0 bis 127 (128 Stufen)
.DB 0,127         ;CV54 minimale Abweichung vom Sollwert bevor Korrektur beginnt von 0 bis <CV53
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB $FF,$FF
.DB 0,$FF         ;CV65 Kickstartzeit 1-256 1=1,28ms 0(256)=327,68ms lang V_laut_CV66 beim anfahren
.DB 0,$FF         ;CV66 KickstartSpannung 0=aus 255=Vmax
.DB 0,$FF         ;CV67 - 94
.DB 0,$FF         ;alternative Geschwindigkeitkennlinie
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
.DB 0,$FF
